
class ScriptSettings {
    settings = []
    prefix = ""
    constructor(prefix = "") {
        this.settings = []
        this.prefix = prefix;
    }

    addSetting(id, name, description, type, defaultValue){
        let v = GM_getValue(this.prefix + id, defaultValue);
        switch (type) {
            case "bool":
                v = !!v;
                break;
            case "string":
            case "text":
                v = "" + v;
                break;
            case "int":
                v = parseInt(v);
                break;
        }

        this.settings[id] = {
            id: id,
            type: type,
            value: v,
            name: name,
            description: description
        };
    }

    setSetting(id, value){
        if(!(id in this.settings)){
            throw "Unknown setting " + id;
        }
        switch (this.settings.type) {
            case "bool":
                value = !!value;
                break;
            case "string":
            case "text":
                value = "" + value;
                break;
            case "int":
                value = parseInt(value);
                break;
        }

        this.settings[id].value = value;
        GM_setValue(this.prefix + id, value);
    }

    getSetting(id){
        if(!(id in this.settings)){
            throw "Unknown setting " + id;
        }
        return this.settings[id].value
    }
}
